
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>A Class Browser Application</h4>

The following is a sample application that implements an NGWS runtime ClassBrowser, using the <b>System.Reflection</b> APIs to gather 
information about a class.  To simplify the .aspx code, the application employs a managed component that encapsulates the reflection
details.  The .aspx page itself relies heavily on several <b>DataList</b> controls for rendering the namespaces, classes, and class 
details.  There is an interesting use of nested DataList controls in this sample as well (for rendering the parameter lists).  View the
sample by clicking the icon below:
<p>

<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/classbrowser/classbrowser.aspx" 
  ViewSource="/quickstart/aspplus/samples/classbrowser/classbrowser.src"
  Icon="/quickstart/aspplus/images/classbrowser_icon.gif"
  Caption="ClassBrowser.aspx"
  runat="server" />

<p>
The ClassBrowser also uses the ASP+ configuration system to determine which modules to load and reflect upon.  We've mapped a 
configuration section to the <b>DictionarySectionHandler</b>, which maintains key/value pairs for the assembly name and 
file.  You can add assemblies to this list by appending a line to the "ClassBrowser" configuration section:
<p>

<div class="code"><pre>
&lt;configuration&gt; 

    &lt;configsections&gt;
       &lt;add name="ClassBrowser" type="System.Web.Configuration.DictionarySectionHandler"/&gt;
    &lt;/configsections&gt;

    &lt;ClassBrowser&gt;
       &lt;set key="ASP+ Class Library" value="System.Web.dll" /&gt;
       &lt;set key="Base Class Library" value="mscorlib.dll" /&gt; 
    &lt;/ClassBrowser&gt;

&lt;/configuration&gt; 
</pre></div>

<p>

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->

