
<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Configuration Overview</h4>

A central requirement of any web application server is a rich and flexible configuration system  one that enables developers to easily 
associate settings with an installable application (without having to bake values into code), and enables administrators to easily 
customize these values post-deployment.  The ASP+ configuration system has been designed to meet the needs of both of these 
audiences, and provides a hierarchical configuration infrastructure that enables extensible configuration data to be defined and 
used throughout an application, site, and/or machine.  It has the following qualities that make it uniquely 
suited to building and maintaining web applications:

<ul>
<li>ASP+ allows configuration settings to be stored together with static content, dynamic pages and business objects within a single 
application directory hierarchy.  A user or administrator simply needs to copy a single directory tree to setup an ASP+ application on a 
machine.
<p>
<li>Configuration data is stored in plaintext files that are both human-readable as well as human-writeable.  Administrators and developers 
can use any standard text editor, XML parser, or scripting language to interpret and update configuration settings.
<p>
<li>ASP+ provides an extensible configuration infrastructure that enables third-party developers to store their own configuration settings, 
define the persistence format of their own configuration settings, intelligently participate in the processing of them, as well as control 
the resulting object model through which those settings are ultimately exposed.  
<p>
<li>Changes to ASP+ configuration files are automatically detected by the system, and are applied without requiring any 
user-intervention (in other words  an administrator should not need to restart the web server or reboot the machine in order for them to take effect).
</ul>

<p>
To learn more about the ASP+ configuration system and how it works, read the following two sections: 
<a href="configformat.aspx">Configuration File Format</a> and <a href="configretrieve.aspx">Retrieving Configuration</a>.

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->