<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>HTML Text Pattern Matching</h4>
This example shows how to create a client proxy for any URI that serves up text. Instead of authoring an .asmx file, you can create 
an SDL file that describes a current HTML (or XML or any other non-binary format) page you currently offer, and this SDL can be used 
to generate a client proxy that will contain properties that correspond to RegEx expressions in the HTML.
<p>

This is done by adding &lt;Match&gt; tags in the Response section of the SDL. These tags take an attribute called <B>pattern</B>, 
which is the Regular Expression that corresponds to the piece of text on the page that is the properties value. (Note: the property from 
the proxy class is read-only.)
<p>

The consuming code can then create the object, access the Matches object that is returned by the functioned name in the SDL, 
and gain particular access to any piece of the HTML as a property. No understanding of SDL, Regular expressions, or even HTML 
is needed to use the proxy class. It behaves like any other NGWS class would.
<p>

<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/services/TextMatching/MatchClient.aspx" 
  ViewSource="/quickstart/aspplus/samples/services/TextMatching/MatchService.src"
  Icon="/quickstart/aspplus/images/matchservice_client.gif"
  Caption="MatchClient.aspx"
  runat="server" />

<p>

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->