<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Using Isolated Data Storage</h4>
At first glance, maintaining data storage with a My Web application seems problematic.  Applications aren't allow to access the file system, so how are they supposed to maintain data storage?  Enter the NGWS runtime's <b>IsolatedStorage</b> feature, which provides a secure, isolated file system abstraction for My Web applications. 
<p>
IsolatedStorage looks and feels like the <b>System.IO.FileStream</b> class that it inherits from.  My Web applications can use IsolatedStorage as a logical replacement for filestreams.  Applications can use IsolatedStorage to persist XML data using the ADO+ XML data access solutions, or use NGWS runtime serialization, or write and maintain files of their own format.

<p>
The following example demonstrates how an application might use file storage.  This is an version of the mortgage calculator application.  This version of the application uses IsolatedStorage and NGWS runtime serializiation services to store and recall the last calculated values across sessions.

<p>
<Acme:SourceRef 
  RunSample="myweb://localhost/quickstart/aspplus/samples/myweb/mortgage3/default.aspx" 
  ViewSource="/quickstart/aspplus/samples/myweb/mortgage3.src"
  Icon="/quickstart/aspplus/images/mortgage3.gif"
  Caption="Mortgage Calculator 3"
  runat="server" />



<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->