<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>The My Web Administration Tool</h4>

<p>My Web includes an Administration Tool that allows the user to easily add, update, and remove My Web applications.  
The My Web Administration Tool can be invoked by either clicking on the My Web toolbar icon located on the Microsoft Internet Explorer toolbar or by typing 
<a href="myweb://">myweb://</a> in the Internet Explorer Address bar.</p>

<p>Invoking the My Web Administration Tool launches the My Web Home Page.  Details of all currently installed applications are displayed on this page.  
A screenshot of this page is displayed below.</p>


<div class="indent">
<img src="/quickstart/aspplus/images/mw_default.gif">
</div>

<p>
<span class="subhead">Installing My Web Applications</span>


<p>There are two types of My Web applications. <b>Remote</b> applications are those obtained from a remote web host. 
<b>Local</b> applications are those whose files have already been stored in the computer's local drive.
</p>

<p>There are two methods of installing remote applications.  The first method involves clicking on the "Install Application" link located on the upper right-hand corner of any 
page of the My Web Administration Tool.  The "Install Application" page similar to the one on the screen shot below is then launched prompting the user to enter the application's URL. 
This URL must be preceded by the "myweb://" protocol scheme. 
</p>

<div class="indent">
<img src="/quickstart/aspplus/images/mw_addlocal_remote.gif">
</div>



<p>Upon detecting the application files in the remote host, the details of the application are displayed on a screen similar to the one shown below.  
This screen also prompts the user to confirm the installation.</p>

<div class="indent">
<img src="/quickstart/aspplus/images/mw_install_remote.gif">
</div>

<p>Once the installation is completed, the details of the newly installed remote application are displayed on the My Web Home Page.</p>

<p>The second method of installing a remote application is by typing its URL (preceeded by the "myweb://" protocol scheme) on the Internet Explorer URL bar.  
If the application has not been previously installed, the My Web "Install Application" page is launched displaying the application's details and prompting the user 
to confirm the installation.  If the application has already been installed, entering its URL in this way, will launch the application.</p>



<p>To install a local application, the user must click on the "Install Application" link 
located on the right-hand corner of any page of the My Web Administration Tool.  
This launches the "Install Application" page which prompts the user to enter the application's local path. </p> 

<p>The next step involves the application's URL alias.  All My Web applications must have a URL alias in order to be launched.  
The URL alias serves as an identifier for the application.  In the case of local applications, a dialog box like the one shown below, appears and prompts
the user to edit the suggested URL alias or leave it unmodified.  </p>

<div class="indent">
<img src="/quickstart/aspplus/images/mw_install_local.gif">
</div>

<p>
The installation process for local applications is completed once the URL alias is submitted.  
The details of the newly installed local application are then displayed on the My Web Home Page.</p>


<p>Any installed application, whether local or remote, can be launched by simply double clicking its corresponding icon displayed on the My Web Home Page.
An alternative way of launching a previously installed application is by typing its URL (preceeded by the "myweb://" protocol scheme) 
on the Internet Explorer URL bar.</p>

<span class="subhead">Updating My Web Applications</span>

<p>The update functionality is only available for remote applications.  
Application updates are executed from the My Web Home Page.  
To update a given application one must click on the "Update" link found on the upper right-hand corner of the entry corresponding to the application to be updated.</p>  

<p>The system proceeds to compare the versions of the files currently installed against the versions of the files found in the application's remote host.  
If a newer version is detected, the user is prompted to confirm the update.  Upon confirmation of the update, the new application files are downloaded
to the local hardrive and the new version of the application is activated. The update confirmation screen is shown below:</p>

<div class="indent">
<img src="/quickstart/aspplus/images/mw_update.gif">
</div>


<p>A local application is updated by simply copying the new files to the application's location on the hard drive. 
The new version of the application is immediately activated.</p>

<span class="subhead">Removing My Web Applications</span>

<p>Once in the My Web Home Page, both local and remote applications can be removed by clicking on the "Remove" link found on the upper right-hand
corner of the entry corresponding to the application in question.  The user is then prompted to confirm the removal of the application through the following screen:</p>

<div class="indent">
<img src="/quickstart/aspplus/images/mw_remove.gif">
</div>

<p>Once an application is removed, its details are no longer displayed on the My Web Home Page</p>



<h4>Section Summary</h4>
<ol>
<li>The My Web Administration Tool enables the user to install, update and remove My Web applications
<li>The My Web Home Page displays the details of all currently installed applications
<li>Through the My Web Administration Tool the user can install both local and remote My Web applications
<li>The update functionality is only available for remote My Web applications
</ol>


<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->
