
<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>MyWeb Application Overview</h4>

The ASP+ My Web feature is an exciting new technology that lets ASP+ applications run on a computer without a web server.  My Web applications are run entirely inside of an Internet Explorer process and can run offline.  These applications use the exact same programming model as server applications--in fact, many applications can be written to run in both environments with few alterations.
<p>
In addition to offline execution, My Web offers a convenient way for end users to <b>demand install</b> applications.  My Web offers an easy way to run and manage installed applications.  My Web also provides a safe execution environment that lets users download and run My Web applications from the Internet in a secure fashion.
<br>
<a name="model">
<br>
<span class="subhead">The My Web Programming Model</span>
<p>
The My Web programming model is identical to the server programming model.  My Web applications can use Web Forms, Web services (to their origin host), and other server APIs.  Differences in My Web applications will typically relate to how they access data, since they run in a strict security context.  Some server applications will need to be partitioned into components and data that make sense to run on the client, while others will be able to run on the client fairly intact.
<p>
Even though My Web applications require some planning, they're an important new way for Web application developers to utilize their skills to write client applications.  In addition to sharing a common programming model, My Web applications offer the same conveniences to developers as other ASP+ applications: rapid development in a productive environment.
<br>
<a name="install">
<br>
<span class="subhead">Demand Installation</span>
<p>
When the user attempts to navigate to a My Web URL, ASP+ first attempts to resolve the application locally.  If the application is already installed locally, it's run as a My Web application.  If the application does not exist locally, ASP+ attempts to locate an application <b>manifest</b> by deriving an HTTP URL from the myweb: URL.  If the manifest is found, it's download and the user is given the choice of installing the application locally.

<p>

Pending user confirmation, ASP+ retrieves the application and installs it locally where it can be run as a My Web application.

<br>
<a name="security">
<br>
<span class="subhead">My Web Security</span>
<p>
My Web applications run in a safe execution environment that relies on the Code Access security features provided with the NGWS runtime.  My Web applications are able to execute, use a safe form of client storage called <b>Isolated Storage</b>, and make network connections back to their host of origin.  They are not permitted to access the local file system or to call native code  or use classic COM components.
<p>
My Web applications also run preserve their remote URL of origin.  For example, an application installed from http://www.microsoft.com/myapplication is accessed locally as myweb://www.microsoft.com/myapplication.  My Web uses this fact to ensure that remote applications and the content that they produce are treated by Internet Explorer as remote applications, where they receive the trust appropriate to their zone.

<h4>Section Summary</h4>
<ol>
<li>My Web applications are ASP+ applications that run inside the browser and don't require an HTTP server
<li>My Web applications use the same programming model and developer skills as server applications do
<li>My Web applications are easy to install
<li>My Web applications run in a secure execution environment
</ol>

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->