
<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>A Personalized Portal</h4>

<p>
This sample illustrates a personalized portal home page application.  The application allows users to customize a home page
to show various <b>modules</b> of their choosing, such as a site directory or favorite links list.  Each module is implemented as a 
<b>Pagelet</b>, which is dynamically added to the home page depending on whether the user has chosen to include it.  The custom
personalization settings are maintained in a SQL database, and are retrieved using a <b>Personalization HttpModule</b> component
(much like the Session or Application State HttpModules work).  Every page in the application inherits from a common Code-Behind 
base Page class, which uses the Personalization component to expose a special dictionary called <b>UserState</b>.  This UserState 
dictionary provides the application's pages access to the per-user customization settings (as key/value String pairs).  In addition
to storing the user's module selections, the UserState dictionary is used to stored other customization parameters such as color
schemes.  Individual modules may use the UserState dictionary to store their own customization settings as well.
<p>
The portal application employs to <b>CookieAuthentication</b> module for user authentication.  When a user first requests the home page,
the settings for an Anonymous user are displayed.  If the user tries to access a portion of the portal which is restricted to authenticated
users (such as the module customization page), the CookieAuthentication module redirects them to a login page where they are 
prompted to enter their credentials.  If the user has not logged in before they may use a registration form to create a new user account
and password.  On subsequent visits to the portal home page they can simply logged in using their account credentials (verified against
a SQL database).
<p>
To get started exploring the portal application, follow the above steps to create a user account.  Once your account is created you may
browse and customize the entire portal.
<p>

<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/portal/default.aspx" 
  ViewSource="/quickstart/aspplus/samples/portal/portal.src"
  Icon="/quickstart/aspplus/images/portal_icon.gif"
  Caption="Portal Application"
  runat="server" />

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->



