<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Using Objects and Intrinsics</h4>
This sample illustrates how to access ASP+ intrinsics, such as the Session and Application objects. It also shows how to turn off Session on a per-[WebMethod] basis.
<p>
The first method in the sample .asmx file, <B>UpdateHitCounter</B> accesses the Session, and adds 1 to the "HitCounter" value. It then returns this value as a String. The second method, <B>UpdateAppCounter</B> does the same thing, but with the Application. Notice the following:

<p>
<div class="code"><pre>
[WebMethod(EnableSession=False)]
</pre></div>
<p>

This turns off Session support, which will speed up this Web Method's performance. Sessions aren't needed for this object, since it only uses the Application object. This compiler directive is recommended in cases where performance is critical.
<p>

<table>
<tr>
<td>
<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/services/Intrinsics/SessionService1.asmx" 
  ViewSource="/quickstart/aspplus/samples/services/Intrinsics/SessionService1.src"
  Icon="/quickstart/aspplus/images/sessionservice_asmx.gif"
  Caption="SessionService.asmx"
  runat="server" />
</td>
<td>
<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/services/Intrinsics/SessionService1.asmx?SDL" 
  Icon="/quickstart/aspplus/images/service_sdl.gif"
  Caption="SessionService.sdl"
  runat="server" />
</td>
</tr>
</table>

<p>
When the client proxy is accessed, it contains a cookie collection. This collection is used to accept and return the APSESSIONID cookie that ASP+ uses to track Sessions. This is what allows this client to receive varying answers to the Session hit method.
<p>

<Acme:SourceRef 
  RunSample="/quickstart/aspplus/samples/services/Intrinsics/SessionService1Client.aspx" 
  ViewSource="/quickstart/aspplus/samples/services/Intrinsics/SessionService1Client.src"
  Icon="/quickstart/aspplus/images/sessionservice_client.gif"
  Caption="SessionServiceClient.aspx"
  runat="server" />

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->