<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>What is ASP+?</h4>

ASP+ is a programming framework built on the NGWS runtime that can be used on a server to build powerful Web Applications. ASP+ offers several important advantages over previous Web development models:

<ul>
<li><b>Enhanced Performance.</b> ASP+ is compiled NGWS runtime code running on the server.  Unlike its interpreted predecessors, ASP+ can take advantage of early binding, just-in-time compilation and native optimization, and caching services, right out-of-the-box.  For developers, this amounts to dramatically better performance before you ever write a line of code.
<p>
<li><b>World-class Tool Support.</b>  The ASP+ framework is complimented by a rich toolbox and designer in the Visual Studio integrated development environment.  WYSIWYG editing, drag-and-drop server controls, and automatic deployment are just a handful of features this powerful tool provides.
<p>
<li><b>Power and Flexibility.</b>  Because ASP+ is based on the NGWS runtime, the power and flexibility of that entire platform is available to web application developers.  The NGWS runtime's Base Class libraries, Messaging, and Data Access solutions are all seamlessly accessible from the web.  ASP+ is also language-independent, so you can choose a language that best applies to your application, or partition your application across many languages.  Further, NGWS runtime interoperability guarantees that your existing investment in COM-based development is preserved when migrating to ASP+.
<p>
<li><b>Simplicity.</b> ASP+ makes it easy to perform common tasks, from simple form submission, to client authentication, to deployment and site configuration.  For example, the ASP+ Page Framework allows you to build user interfaces that cleanly separate application logic from presentation code, and handle events in a simple, VB-like forms processing model.  Additionally, the NGWS runtime simplifies development with managed code services like automatic reference counting and garbage collection.  
<p>
<li><b>Manageability.</b>  ASP+ employs a text-based, hierarchical configuration system, which simplifies applying settings to your server environment and web applications.  Because configuration information is stored as plain-text, new settings may be applied without the aid of local administration tools.  This "zero local administration" philosophy extends to deploying ASP+ applications as well.  An ASP+ application is deployed to a server simply by copying the necessary files to the server. No server restart is required, even to deploy or replace running compiled code! 
<p>
<li><b>Scalability and Availability.</b>  ASP+ has been designed with scalability in mind, with features specifically tailored to improve performance in clustered and multi-processor environments.  Further, processes are closely monitored and managed by the ASP+ runtime, so that if one misbehaves (leaks, deadlocks), a new process can be created in its place, which helps keep your application constantly available to handle requests.
<p>
<li><b>Customizability and Extensibility.</b>  ASP+ delivers a well-factored architecture that allows developers to "plug-in" their code at the appropriate level.  In fact, it is possible to extend or replace any sub-component of the ASP+ runtime with your own custom-written component. Implementing custom authentication or state services has never been easier.
<p>
<li><b>Security.</b>  With built in Windows authentication and per-application configuration, you can be assured your applications are secure.
</ul>

In the remainder of the Quick Start, we'll see practical examples of the above concepts.  Continue reading to see how ASP+ can work for you!

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->