<%@ Register TagPrefix="Acme" TagName="SourceRef" Src="/quickstart/util/SrcRef.aspx"%>

<!-- #include virtual="/quickstart/aspplus/include/header.inc" -->

<h4>Writing a Simple MyWeb Application</h4>

Writing a My Web application is very similar to writing an ASP+ server application.  The application consists of a combination of ASP+ pages, static content, and business components.  After developing the application, authors simply create a CAB file containing the application directory hierarchy and produce a simple manifest file describing the application.
<p>
<a name="cabbing">
<span class="subhead">Creating a CAB File</span>
<p>
Creating a CAB file can be done with a utility such as CABARC.  CABARC can be downloaded as part of the <a target="_new" href="http://msdn.microsoft.com/workshop/management/cab/cabdl.asp">Microsoft Cabinet SDK</a>.  Reference instructions for the utility can be found on the <a target="_new" href="http://msdn.microsoft.com/workshop/components/activex/packaging.asp">MSDN site</a>.
<p>
The following command, executed in the application root of the My Web application that you're preparing for distribution would create a CAB file consisting of all the ASP+ pages, HTML files, images, style sheets, and business logic under the current hierarchy.
<p>
<div class="code"><xmp>
 cabarc -p -r n myweb.cab *.aspx *.htm* *.jpg *.gif *.css *.dll *.web
</xmp></div>

<a name="manifests">
<span class="subhead">Creating a Manifest File</span>
<p>
A My Web <b>manifest</b> file is an XML file in the Open Software Description (OSD) format.  By convention, My Web manifest files are named myweb.osd.  A simple version of a manifest follows:

<div class="code"><xmp>
<softpkg name="Mortgage Calculator Demo 1"  version="1.0" >
    <implementation>
        <codebase href="http://somewhere.com/myweb.cab" />
    </implementation>		
    <homepage>myweb://somewhere.com/default.aspx</homepage>
    <Iconurl>myweb://somewhere.com/icon.gif</Iconurl>
    <RemoteIconurl>http://somewhere.com/icon.gif</RemoteIconurl>
    <Author>John Doe</Author>
    <Source>Somewhere, Inc.</Source>
    <size>3000</size>
</softpkg>
</xmp></div>
<p>
The following sample consists of a simple My Web application.  The application contains a single ASP+ page, which implements a rudimentary mortgage calculator.  There is a simple manifest and a CAB file that contains the ASP+ page and and image, used as the icon for the My Web admin UI.
<p>
To run the sample, click on the "Run Sample" link and continue on with the installation when prompted.  After the application is installed, you can run the application by clicking on its icon in from the My Web home page.
<p>

<Acme:SourceRef 
  RunSample="myweb://localhost/quickstart/aspplus/samples/myweb/mortgage1/default.aspx" 
  ViewSource="/quickstart/aspplus/samples/myweb/mortgage1.src"
  Icon="/quickstart/aspplus/images/mortgage1.gif"
  Caption="Mortgage Calculator 1"
  runat="server" />

<p>
<a name="localapps">
<span class="subhead">Using My Web to Run Local Applications</span>
<p>
You can also use My Web to run applications from a local drive which do not need to be packaged for deployment (that is, they do not require CAB files or manifests).  To do this, just enter the file path (e.g. c:\myapp) to the application from the Install page.  The installation procedure will allow a URL to be mapped to the file path (e.g. myweb://localhost/myapp) and the application can then be run.  Local applications are not deleted or updated by My Web.

<!-- #include virtual="/quickstart/aspplus/include/footer.inc" -->